#ifndef __QUADTREE_H__
#define __QUADTREE_H__


#include <stdlib.h>

typedef struct struct_quadtree {
	void *nw;
	void *ne;
	void *sw;
	void *se;

	int level;
	/* offset in the buffer */
	int idx;
	/* dimensions */
	int m;
	int n;

	int id;
	/* starting position in the matrix */
	int x;
	int y;

	int leaf;
} quadtree_t;


static inline __attribute((always_inline)) quadtree_t * qtree_create_elem(int level, int m, int n) {
	quadtree_t *t = calloc( 1, sizeof(quadtree_t) );
	t->level = level;
	t->m = m;
	t->n = n;
	t->id = -1;
	t->leaf = 0;

	return t;
}

#endif // __QUADTREE_H__
