#ifndef __FPLAPACK_H__
#define __FPLAPACK_H__


#include "config.h"

#include "fpblas.h"


#if USE_MKL

#include "mkl.h"

#ifdef SINGLE_PRECISION

#define LAPACK_getrf(m, n, A, lda, ipiv, info) 									LAPACKE_sgetrf( LAPACK_COL_MAJOR, m, n, A, lda, ipiv )
#define LAPACK_laswp(n, A, lda, k1, k2, ipiv, incx)								LAPACKE_slaswp( LAPACK_COL_MAJOR, n, A, lda, k1, k2, ipiv, incx)

#else

#define LAPACK_getrf(m, n, A, lda, ipiv, info) 									LAPACKE_dgetrf( LAPACK_COL_MAJOR, m, n, A, lda, ipiv )
#define LAPACK_laswp(n, A, lda, k1, k2, ipiv, incx)								LAPACKE_dlaswp( LAPACK_COL_MAJOR, n, A, lda, k1, k2, ipiv, incx)

#endif 


#else /* NOT MKL */


#include "blas.h"

#ifdef SINGLE_PRECISION

#define LAPACK_getrf(m, n, A, lda, ipiv, info) 									sgetrf_(&m, &n, A, &lda, ipiv, info)
#define LAPACK_laswp(n, A, lda, k1, k2, ipiv, incx)								slaswp_(&n, A, &lda, &k1, &k2, ipiv, &incx)

#else

#define LAPACK_getrf(m, n, A, lda, ipiv, info) 									dgetrf_(&m, &n, A, &lda, ipiv, info)
#define LAPACK_laswp(n, A, lda, k1, k2, ipiv, incx)								dlaswp_(&n, A, &lda, &k1, &k2, ipiv, &incx)

#endif // PRECISION


#endif // MKL


#endif // __FPLAPACK_H__
