#ifndef __FPT_H__
#define __FPT_H__


#define I_ONE	1
#define I_MONE	-1
#define F_ONE	1.0
#define F_MONE	-1.0


#ifdef SINGLE_PRECISION

typedef float fp_t;

#define FP_ONE 		s_one
#define FP_MONE 	s_mone
#define FP_NOUGHT	s_zero

#define FP_RAND 	drand48
#define FP_SEED 	srand48
#define FP_ABS		fabsf
#define FP_POW		powf

#else

typedef double fp_t;

#define FP_ONE 		d_one
#define FP_MONE 	d_mone
#define FP_NOUGHT 	d_zero

#define FP_RAND 	drand48
#define FP_SEED 	srand48
#define FP_ABS		fabs
#define FP_POW		pow

#endif 


extern int i_one;
extern int i_mone;

extern double d_one;
extern double d_zero;
extern double d_mone;

extern float s_one;
extern float s_mone;
extern float s_zero;


#endif // __FPT_H__
