#include "tasks_gemm.h"

#include "fptype.h"
#include "fpblas.h"
#include "blas.h"


#ifdef DOUBLE_PRECISION
#define __t_gemm			task_dgemm
#else
#define __t_gemm			task_sgemm
#endif

#define DRYRUN	0

// C = alpha * A * B - beta * C
// A bm x bk 
// B bk x bn 
// C bm x bn 
void __t_gemm(int bm, int bn, int bk, fp_t alpha, fp_t *A, int ldimA, fp_t *B, int ldimB, fp_t beta, fp_t *C, int ldimC) {
#if ! DRYRUN
	BLAS_gemm(MAT_NOTRANSP, MAT_NOTRANSP, bm, bn, bk, alpha, A, ldimA, B, ldimB, beta, C, ldimC);
#endif
}




