#include "blocked.h"

#include "fptype.h"


#ifdef DOUBLE_PRECISION
#define __BCM2CM 	dbcm2cm
#else
#define __BCM2CM 	sbcm2cm
#endif


fp_t *__BCM2CM(int b, int c, int m, int n, fp_t *Ab) {
	fp_t *A = malloc(sizeof(fp_t) * m * n);
	int bc = b * c; /* block size */
	int cs = m * c; /* number of elements in a block column */

	int j;
	for ( j = 0; j < n; ++j ) {
		int i;
		for ( i = 0; i < m; ++i ) {
			int bi = i / b;
			int bj = j / c;

			int ei = i % b;
			int ej = j % c;

			fp_t *block = &Ab[ bj * cs + bi * bc];
			A[j*m+i] = block[ej * b + ei];
		}
	}

	return A;
}
