#ifndef __GENMAT_H__
#define __GENMAT_H__


#include "fptype.h"


#ifdef DOUBLE_PRECISION
#define 	GENMAT			dgenmat
#define 	GENMAT_DD		dgenmat_dd
#define 	GENMAT_COVAR	dgenmat_covariant
#else
#define 	GENMAT			sgenmat
#define 	GENMAT_DD		sgenmat_dd
#define 	GENMAT_COVAR	sgenmat_covariant
#endif


void *sgenmat(int m, int n);
void *sgenmat_dd(int n);
void *sgenmat_covariant(int n, fp_t p, fp_t k);

void *dgenmat(int m, int n);
void *dgenmat_dd(int n);
void *dgenmat_covariant(int n, fp_t p, fp_t k);


#endif // __GENMAT_H__
