#include "matfprint.h"

#include <stdio.h>

#if 0
fprint_hb2mm(const char *fname, const hbmat_t *Ahb) {
	int *vptr = A->vptr;
	int *vpos = A->vpos;
	double *vval = A->vval;
	int n = A->n;
}
#endif


void fprint_csr2mm(const char *fname, int m, const int *vptr, const int *vpos, const double *vval, int offs) {
	int roffs = 1 - offs;
	FILE *f = fopen(fname, "w");
	
	int i;
	for ( i=0; i<m; ++i ) {
		int rowb = vptr[i] - offs;
		int rowe = vptr[i+1] - offs;
		int j;
		for ( j=rowb; j<rowe; ++j ) {
			if ( vval == NULL ) {
				fprintf(f, "%i\t%i\t1\n", i+1, vpos[j] + roffs);
			} else {
				fprintf(f, "%i\t%i\t%.16f\n", i+1, vpos[j] + roffs, vval[j]);
			}
		}
	}

	fclose(f);
}


void print_sdense2mm(FILE *f, const char *name, int m, int n, const float *A, int ldim) {
	fprintf(f, "# name: %s\n", name);
	fprintf(f, "# type: matrix\n");
	fprintf(f, "# rows: %i\n", m);
	fprintf(f, "# columns: %i\n", n);

	int i;
	for ( i=0; i<m; ++i ) {
		int j;
		for ( j=0; j<n; ++j ) {
				fprintf(f, "%.16f ", A[j*ldim+i]);
		}
		fprintf(f, "\n");
	}
}


void fprint_sdense2mm(const char *fname, const char *name, int m, int n, const float *A, int ldim) {
	FILE *f = fopen(fname, "w");
	if ( f == NULL ) {
		fprintf(stderr, "err: cannot open %s for writing\n", fname);
	}

	print_sdense2mm(f, name, m, n, A, ldim);

	fclose(f);
}


void print_ddense2mm(FILE *f, const char *name, int m, int n, const double *A, int ldim) {
	printf("warning: writing obj %s\n", name);

	fprintf(f, "# name: %s\n", name);
	fprintf(f, "# type: matrix\n");
	fprintf(f, "# rows: %i\n", m);
	fprintf(f, "# columns: %i\n", n);

	int i;
	for ( i=0; i<m; ++i ) {
		int j;
		for ( j=0; j<n; ++j ) {
				fprintf(f, "%.16f ", A[j*ldim+i]);
		}
		fprintf(f, "\n");
	}
}


void fprint_ddense2mm(const char *fname, const char *name, int m, int n, const double *A, int ldim) {
	FILE *f = fopen(fname, "w");
	if ( f == NULL ) {
		fprintf(stderr, "err: cannot open %s for writing\n", fname);
	}

	print_ddense2mm(f, name, m, n, A, ldim);

	fclose(f);
}


void fprint_suff_sdense2mm(const char *fname, int suff, const char *name, int m, int n, const float *A, int ldim) {
		char buf1[128];
		char buf2[128];
		sprintf(buf1, "%s_%i.mm", name, suff);
		sprintf(buf2, "%s_%i", name, suff);

		fprint_sdense2mm(buf1, buf2, m, n, A, ldim);
}

void fprint_suff_ddense2mm(const char *fname, int suff, const char *name, int m, int n, const double *A, int ldim) {
		char buf1[128];
		char buf2[128];
		sprintf(buf1, "%s_%i.mm", name, suff);
		sprintf(buf2, "%s_%i", name, suff);

		fprint_ddense2mm(buf1, buf2, m, n, A, ldim);
}
