#include "matmul_config.h"

#include <stdio.h>


extern int m;
extern int k;
extern int n;
extern int rm;
extern int rk;
extern int rn;
extern int b;
extern int c;
extern int d;
extern int reps;
extern int check;


int matmul_config(int argc, char *argv[]) { 
	if (argc < 7 ) {
		fprintf(stderr, "use: %s m n k b d c [reps] [check]\n", argv[0]);
		return 1;
	}

  	rm = m = atoi(argv[1]);
  	rn = n = atoi(argv[2]);
  	rk = k = atoi(argv[3]);
  	b = atoi(argv[4]);
  	d = atoi(argv[5]);
  	c = atoi(argv[6]);

	if ( b > m || c > k || d > n ) {
		fprintf(stderr, "error: block dimension exceeds matrix dimension\n");
		return 1;
	}

	if (m % b != 0) {
		rm = ( ( m + b - 1 ) / b ) * b;
		fprintf(stdout, "warning: padding m to %i\n", rm);
	}
	if (k % c != 0) {
		rk = ( ( k + c - 1 ) / c ) * c;
		fprintf(stdout, "warning: padding k to %i\n", rk);
	}
	if (n % d != 0) {
		rn = ( ( n + d - 1 ) / d ) * d;
		fprintf(stdout, "warning: padding n to %i\n", rn);
	}

	reps = 1;
	check = 0;
	if (argc > 7) {
		reps = atoi(argv[7]);
		if (argc > 8) {
			check = atoi(argv[8]);
		}
	}

	return 0;
}
