#ifndef __OMPSS_ARNOLDI_H__
#define __OMPSS_ARNOLDI_H__


#include <malloc.h>


#ifdef __cplusplus
extern "C" {
#endif


#ifdef LIBOMPSS_BUILDING
#define LIBOMPSS_DLL_EXPORTED __attribute__((__visibility__("default")))
#else
#define LIBOMPSS_DLL_EXPORTED
#endif


extern LIBOMPSS_DLL_EXPORTED void * ompss_sarn_init(int m, int b);

/*	A (input) : mxm matrix 
	Q (output ) : mxn matrix 
	H (output) : 
	b : block size */
extern LIBOMPSS_DLL_EXPORTED int ompss_sarn(int m, int n, int b, float *A, float **Q, float **H, void *work);  

extern LIBOMPSS_DLL_EXPORTED void ompss_sarn_fini(void *work);

extern LIBOMPSS_DLL_EXPORTED void * ompss_darn_init(int m, int b);

extern LIBOMPSS_DLL_EXPORTED int ompss_darn(int m, int n, int b, double *A, double **Q, double **H, void *work);

extern LIBOMPSS_DLL_EXPORTED void ompss_darn_fini(void *work);


#ifdef __cplusplus
}
#endif


#endif // __OMPSS_ARNOLDI_H__
