#include "matmul_config.h"

#include <stdio.h>


extern int m;
extern int k;
extern int n;
extern int rm;
extern int rk;
extern int rn;
extern int b;
extern int c;
extern int d;
extern unsigned int l;
extern int reps;
extern int check;


int matmul_config(int argc, char *argv[]) { 
	if (argc < 5 ) {
		fprintf(stderr, "use: %s m k n l [reps] [check]\n", argv[0]);
		return 1;
	}

  	m = atoi(argv[1]);
  	k = atoi(argv[2]);
  	n = atoi(argv[3]);

  	l = atoi(argv[4]);

	int tentb = m;
	int tentc = k;
	int tentd = n;
	int i;
	for ( i = 0; i < l; ++i ) {
		tentb = tentb >> 1;
		tentc = tentc >> 1;
		tentd = tentd >> 1;
	}

	int tentm = tentb;
	int tentk = tentc;
	int tentn = tentd;
	for ( i = 0; i < l; ++i ) {
		tentm = tentm << 1;
		tentk = tentk << 1;
		tentn = tentn << 1;
	}

	b= ( tentm < m ) ? tentb + 1: tentb;
	c= ( tentk < k ) ? tentc + 1: tentc;
	d= ( tentn < n ) ? tentd + 1: tentd;

	rm = b;
	rk = c;
	rn = d;

	for ( i = 0; i < l; ++i ) {
		rm = rm << 1;
		rk = rk << 1;
		rn = rn << 1;
	}

	printf("info: block dim %i %i %i\n", b, c, d);

	if ( m!=rm || k!=rk || n!=rn ) {
		printf("warning: padding dimensions to %i %i %i\n", rm, rk, rn);
	}

	reps = 1;
	check = 0;
	if (argc > 5) {
		reps = atoi(argv[5]);
		if (argc > 6) {
			check = atoi(argv[6]);
			if ( check > 0 ) {
				printf("warning: enabling error check\n");
			}
		}
	}

	return 0;
}
