#ifndef __BASIC_KERNELS_H__
#define __BASIC_KERNELS_H__


void strassen_mm(int b, int c, int d, int m, int k, int n, double *A, double *B, double *C, double *S, unsigned long *scratchs);


#pragma omp task in( [size]P1, [size]P4, [size]P5, [size]P7 ) inout( [size]P7 )
void strassen_C1122(int size, double *P1, double *P4, double *P5, double *P7);

#pragma omp task in( [size]P2, [size]P3 ) inout( [size]P4, [size]P5 )
void strassen_C1221(int size, double *P2, double *P3, double *P4, double *P5);


#pragma omp task in( [b][c]A, [c][d]B ) out( [b][d]C )
void basic_mm(int b, int c, int d, double *A, double *B, double *C);


#pragma omp task in( [s]b11, [s]b12, [s]b21, [s]b22 ) out( [s]b1122, [s]b2122, [s]b1112, [s]b2111, [s]b1222 )
void strassen_b(int s, double *b11, double *b12, double *b21, double *b22, 
	double *b1122, double *b2122, double *b1112, double *b2111, double *b1222);


#endif // __BASIC_KERNELS_H__
