#include "strassen_main.h"
#include "strassen_kernels.h"

#include <stdio.h>
#include <sys/time.h>


unsigned long scratchs;


unsigned long strassen_main(int b, int c, int d, int m, int k, int n, double *A, double *B, double *C, double *S) {
	scratchs = 0;

	struct timeval start;
	gettimeofday( &start, NULL );

	strassen_mm(b, c, d, m, k, n, A, B, C, S, &scratchs);

#pragma omp taskwait

	struct timeval stop;
	gettimeofday(&stop,NULL);

	unsigned long interm = stop.tv_usec - start.tv_usec;
	interm += (stop.tv_sec - start.tv_sec ) * 1000000;

	return interm;
}
