#include "matmul_setup.h"


#include <stdlib.h>
#include <time.h>
#include <math.h>

#include "fptype.h"
#include "genmat.h"
#include "quadtree.h"
#include "stack.h"
#include "morton.h"

#define max(a,b) (a) > (b)? (a) : (b)
#define min(a,b) (a) > (b)? (b) : (a)

extern fp_t *A;
extern fp_t *B;
extern fp_t *C;
extern fp_t *S;
extern unsigned int l;
extern unsigned long sscratchs;


static unsigned long ipow(unsigned long base, unsigned long exp) {
    unsigned long res = 1;
    while ( exp ) {
        if ( exp & 1 ) {
            res *= base;
	}
        exp >>= 1;
        base *= base;
    }

    return res;
}


int matmul_setup(int check, int m, int mm, int k, int kk, int n, int nn, int b, int c, int d) {
	int ac = mm * kk;
	int bc = kk * nn;
	A = dgenmat(mm, kk);
	B = dgenmat(kk, nn);
	C = calloc(mm * nn, sizeof(double) );

	sscratchs = ( mm * nn * (ipow(7,l) - ipow(4,l) ) ) / ( ipow(4,l)); 
	sscratchs += ( 5 * (mm * kk + kk * nn) * ( ipow(7, l) - ipow(4, l) ) ) / ( 3 * ipow(4,l) );
	printf("setup: allocated %lu + %lu Mb\n", ( mm * kk + kk * nn  + mm * nn ) * sizeof(double) / ( 1024 * 1024 ), sscratchs * sizeof(double) / (1024 * 1024) );
	S = calloc(sscratchs, sizeof(double));

	return 0;
}


int matmul_shutdown(int check, int m, int mm, int k, int kk, int n, int nn, int b, int c, int d) {
	free(A);
	free(B);
	free(C);
	free(S);

	return 0;
}
