#include "matmul_setup.h"

#include <stdlib.h>
#include <time.h>
#include <math.h>

#include "quadtree.h"
//#include "stack.h"
#include "morton.h"


#define max(a,b) (a) > (b)? (a) : (b)
#define min(a,b) (a) > (b)? (b) : (a)


extern double *A;
extern double *B;
extern double *C;
extern double *S;
extern int l;
extern unsigned long sscratchs;


static unsigned long ipow(unsigned long base, unsigned long exp) {
    unsigned long res = 1;
    while ( exp ) {
        if ( exp & 1 ) {
            res *= base;
	}
        exp >>= 1;
        base *= base;
    }

    return res;
}


int matmul_setup(int check, int m, int mm, int k, int kk, int n, int nn, int b, int c, int d) {
	A = dgenmat(mm, kk);
	B = dgenmat(kk, nn);
	C = malloc( mm * nn * sizeof(double) );

	sscratchs = ( ( 5 * mm * nn ) * ( ipow(7,l) - ipow(4,l) ) ) / ( 3 * ipow(4,l) );
	if ( l != 0 ) {
		sscratchs += ( ( mm * kk + kk * nn ) * ( ipow(7,l) - ipow(4,l) ) ) / ( 3 * ipow(4,l-1) );
	}

	S = calloc( sscratchs, sizeof(double) );
	
	printf("setup: allocated %lu + %lu Mb\n", ( mm * kk + kk * nn  + mm * nn ) * sizeof(double) / ( 1024 * 1024 ), sscratchs * sizeof(double) / (1024 * 1024) );
	
	return 0;
}



int matmul_shutdown(int check, int m, int mm, int n, int nn, int k, int kk, int b, int d, int c) {
	free(A);
	free(B);
	free(C);
	free(S);
	
	return 0;
}
