#ifndef __WINOGRAD_KERNELS_H__
#define __WINOGRAD_KERNELS_H__


#pragma omp task in( [s]A, [s]B) out( [s]C )
void basic_mm(int s, int c, int d, double *A, double *B, double *C);


#pragma omp task in( [s]A, [s]B, [s]C, [s]D ) out( [s]E, [s]F, [s]G, [s]H ) 
void wino_a(int s, double *A, double *B, double *C, double *D, double *E, double *F, double *G, double *H);


#pragma omp task in( [s]A, [s]B, [s]C, [s]D ) out( [s]E, [s]F, [s]G, [s]H ) 
void wino_b(int s, double *A, double *B, double *C, double *D, double *E, double *F, double *G, double *H);


#pragma omp task in( [s]P2, [s]P4, [s]P5 ) out( [s]U2, [s]U3 ) inout( [s]C11 );
void wino_madd4(int s, double *P2, double *P4, double *P5, double *C11, double *U2, double *U3);


//#pragma omp task in( [s]U3, [s]P3, [s]U2 ) out( [s]C21, [s]C22 ) inout( [s]C12, [s]C21 )
#pragma omp task in( [s]U3, [s]U2 ) out( [s]C21 ) inout( [s]C12, [s]C21, [s]C22 )
void wino_madd5(int s, double *U3, double *U2, double *C21, double *C22, double *C12);



#endif // __WINOGRAD_KERNELS_H__
