#include "wino_kernels.h"


void wino_a(int s, double *A, double *B, double *C, double *D, double *E, double *F, double *G, double *H) {
	int i;
	for ( i = 0; i < s; ++i ) {
		E[i] = A[i] + B[i];
		F[i] = E[i] - C[i];
		G[i] = C[i] - A[i];
		H[i] = D[i] - F[i];
	}
}

void wino_b(int s, double *A, double *B, double *C, double *D, double *E, double *F, double *G, double *H) {
	int i;
	for ( i = 0; i < s; ++i ) {
		E[i] = A[i] - B[i];
		F[i] = C[i] - E[i];
		G[i] = C[i] - A[i];
		H[i] = D[i] - F[i];
	}
}

void wino_madd4(int s, double *P2, double *P4, double *P5, double *C11, double *U2, double *U3) {
	int i;
	for ( i = 0; i < s; ++i ) {
		U2[i] = C11[i] + P4[i];
		C11[i] += P2[i];
		U3[i] = U2[i] + P5[i];
	}
}


//void wino_madd5(int s, double *U3, double *P7, double *P3, double *U2, double *P6, double *C21, double *C22, double *U6, double *C12) {
#if 1
void wino_madd5(int size, double *U3, double *U2, double *C21, double *C22, double *C12) {
        int i;
        for ( i = 0; i < size; ++i ) {
                C21[i] += U3[i];  
                //U6[i] = U2[i] + P3[i];
                C12[i] += U2[i] + C22[i];  
                C22[i] += U3[i];  
        }
}
#else
void wino_madd5(int s, double *U3, double *P7, double *U2, double *C21, double *U6, double *C22, double *C12) {
	int i;
	for ( i = 0; i < s; ++i ) {
		C21[i] = U3[i] + P7[i];
		U6[i] = U2[i] + C22[i];
		C22[i] += U3[i];  
		C12[i] += U6[i];  
	}
}
#endif
